package business;

import access.ProgramListenerMapTableDB;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;
import java.io.Serializable;


public class ProgramListenerMapTable implements Serializable
{
    private Hashtable htProgramMapper;

    public ProgramListenerMapTable()
    {
        //System.out.println("CRETAED.........................");
        ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
        if( (htProgramMapper=objPLMTDB.retrieveMapTable()) == null)
        {
            //System.out.println("HASH nEW");
            htProgramMapper = new Hashtable();
        }
        else
        {
            //         System.out.println("STAT PLMT TABLE  "+((ProgramListenerMapper)htProgramMapper.get("Test.java")));
            // System.out.println("LISTENER "+((ProgramListenerMapper)htProgramMapper.get("Test.java")).getListeners());

        }

    }

    public Vector getProgramNames()
    {
        Enumeration objEnum=htProgramMapper.keys();
        Vector vVector = null;
        if(objEnum.hasMoreElements()==true)
        {
            vVector = new Vector();
        }
        while(objEnum.hasMoreElements())
        {
            vVector.add(objEnum.nextElement());
        }
        return vVector;
    }
    public ProgramListenerMapper getProgramMapper(String sProgramName)
    {
        //System.out.println("sProgramName : "+sProgramName);
        if(htProgramMapper!=null && sProgramName!=null)
        {
            if(htProgramMapper.get(sProgramName)!=null)
                return (ProgramListenerMapper) htProgramMapper.get(sProgramName);
            else
                return null;
        }
        else
            return null;
    }

    public  Vector[] getListeners(String sProgramName)
    {
        //System.out.println("sProgramName : "+sProgramName);
        if(this.getProgramMapper(sProgramName)!=null)
            return this.getProgramMapper(sProgramName).getListeners();
        else{
            //System.out.println("Null returned by getProgramMapper");
            return null;
        }
    }



    public boolean registerProgram(String sProgramName)
    {
        ProgramListenerMapper objPLM = new ProgramListenerMapper();
        objPLM.setProgramName(sProgramName);
        //System.out.println("HASH = "+htProgramMapper+" PLM :"+objPLM);
        System.out.println("Register Program : " + sProgramName);
        htProgramMapper.put(sProgramName,objPLM);
        ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
        objPLMTDB.storeMapTable(htProgramMapper);

        return true;
    }

    public boolean unRegisterProgram(String sProgramName)
    {
        ProgramListenerMapper objPLM = getProgramMapper(sProgramName);

        System.out.println("Unregister Program : " + sProgramName);
        htProgramMapper.remove(objPLM);
        ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
        objPLMTDB.storeMapTable(htProgramMapper);

        return true;
    }

    public boolean registerProgramForListener(String sProgramName, ListenerInfo objLI)
    {

        ProgramListenerMapper objPLM = getProgramMapper(sProgramName);

        if(objPLM != null)
        {
            //System.out.println("PLM inside registerProgramforListener" + objPLM);
            objPLM.addListener(objLI);
            ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
            objPLMTDB.storeMapTable(htProgramMapper);
            return true;
        }
        else
        {
            return false;
        }
    }

    public boolean unRegisterProgramForListener(String sProgramName, ListenerInfo objLI)
    {

        ProgramListenerMapper objPLM = getProgramMapper(sProgramName);
        if(objPLM != null)
        {
            //System.out.println("PLM inside UnregisterProgramforListener" + objPLM);
            objPLM.removeListener(objLI);
            ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
            objPLMTDB.storeMapTable(htProgramMapper);
            return true;
        }
        else
        {
            return false;
        }

    }

    public void unRegisterListener(ListenerInfo objLI)
    {
        Vector vPrograms=getProgramNames();
        if(vPrograms!=null)
        {
            for(int i=0;i<vPrograms.size();i++)
            {
                String sProgramName=vPrograms.get(0).toString();
                if(htProgramMapper.get(sProgramName)!=null)
                    ((ProgramListenerMapper) htProgramMapper.get(sProgramName)).removeListener(objLI);

            }
            ProgramListenerMapTableDB  objPLMTDB = new ProgramListenerMapTableDB();
            objPLMTDB.storeMapTable(htProgramMapper);
        }
    }

    public void updateListenerInfo()
    {
        Enumeration objEnum = htProgramMapper.keys();

        while(objEnum.hasMoreElements())
        {
            ProgramListenerMapper objPLM=(ProgramListenerMapper) htProgramMapper.get(objEnum.nextElement());
            objPLM.getListeners();
        }
        ProgramListenerMapTableDB   objDB = new ProgramListenerMapTableDB();
        objDB.storeMapTable(htProgramMapper);
    }

}