package view;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.util.Vector;

import access.DatabaseConstants;
import business.ConfigurationManager;


public class ConfigurationServerUI extends JFrame implements WindowListener, DatabaseConstants, ListSelectionListener{

  //private GridBagConstraints objGBC = new GridBagConstraints();
  private DefaultListModel dlmProgramsList = new DefaultListModel();

  private DefaultTableModel dtmProgramListenerInfo ;//= new DefaultTableModel(new String[]{"IP Address", "Port No","Status"},0);
  private JTable jtConfiguration = new JTable(dtmProgramListenerInfo);
  //TitledBorder titledBorder1 = new TitledBorder("");
  TitledBorder titledBorder2 = new TitledBorder("Program Name");
  TitledBorder titledBorder3 = new TitledBorder("Configuration Details");
  ConfigurationManager objCM = new ConfigurationManager();
  JTabbedPane jtpConfServer = new JTabbedPane();
  JPanel jpConfServer = new JPanel();
  BorderLayout blConfigurationServer = new BorderLayout();
  JPanel jpHeader = new JPanel();
  FlowLayout objFLLabel = new FlowLayout();
  FlowLayout objFLHeader = new FlowLayout();
  JLabel jlblStatus = new JLabel();
  JPanel jpLabel = new JPanel();
  JList jlPrograms = new JList(dlmProgramsList);
  JPanel jpContents = new JPanel();
  JLabel jlblHeader = new JLabel();
  JScrollPane jspConfiguration;// = new JScrollPane(jtConfiguration);
  JScrollPane jspPrograms = new JScrollPane();
  JPanel jpNetworkInfo = new JPanel();
  BorderLayout blNetworkInfo = new BorderLayout();
  JPanel jpNetworkInfoHeader = new JPanel();
  JPanel jpNetworkInfoStatus = new JPanel();
  JPanel jpNetworkInputs = new JPanel();
  JPanel jpConfServerInfo = new JPanel();
  JLabel jlblConfServerIPAddress = new JLabel();
  JLabel jlblConfServerPortNo = new JLabel();
  JTextField jtfIPAddress = new JTextField();
  JTextField jtfPortNo = new JTextField();
  JButton jbUpdate = new JButton();
  JLabel jlblNetworkInfo = new JLabel();
  JLabel jlProgramsList = new JLabel();
  JLabel jlblListenersList = new JLabel();

  JButton jbRefresh = new JButton("Refresh");

  public ConfigurationServerUI() {
    try {
      jbInit();
      this.getContentPane().setBounds(100,100,520,400);
      this.setVisible(true);
      this.show();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
          //-------------------------------------------------------------------------------------
          //   objCM.setNetworkInfo("localhost","1099");
          //-------------------------------------------------------------------------------------
  }

  public void windowClosing(WindowEvent we)
  {
    this.setVisible(false);
    System.exit(0);
  }

  public void windowClosed(WindowEvent we)
  {
    this.setVisible(false);
    System.exit(0);
  }
  public void windowOpened(WindowEvent we)
  {

  }
  public void windowDeactivated(WindowEvent we)
  {

  }
  public void windowActivated(WindowEvent we)
  {

  }
  public void windowDeiconified(WindowEvent we)
  {

  }
  public void windowIconified(WindowEvent we)
  {

  }

  public void valueChanged(ListSelectionEvent lse)
  {
    System.out.println(jlPrograms.getSelectedValue());
    loadProgramListenerInfo((String)jlPrograms.getSelectedValue());

  }

  public void loadPrograms()
  {
    Vector vProgramNames = ConfigurationManager.getProgramNames();

      if(vProgramNames !=null)
      {
          for(int iLoop=0; iLoop<vProgramNames.size();iLoop++)
          {
              dlmProgramsList.addElement(vProgramNames.get(iLoop));
          }
      }

  }

  public void loadProgramListenerInfo(String sProgramName)
  {
    //jtConfiguration.removeAll();
    dtmProgramListenerInfo.setRowCount(0);

    Vector[] vListenerInfo = ConfigurationManager.getListeners(sProgramName);

    if(vListenerInfo !=null)
    {
        //System.out.println("Listener Info Vector Size : " + vListenerInfo[0].size());
        dtmProgramListenerInfo.setRowCount(vListenerInfo[0].size());
        for(int iLoop=0; iLoop< vListenerInfo[0].size(); iLoop++)
        {
            dtmProgramListenerInfo.setValueAt(vListenerInfo[0].get(iLoop),iLoop,0);
            dtmProgramListenerInfo.setValueAt(vListenerInfo[1].get(iLoop),iLoop,1);
            //System.out.println(((Boolean)(vListenerInfo[2].get(iLoop))).booleanValue());
            System.out.println(vListenerInfo[2].size());
            boolean bStatus = ((Boolean)vListenerInfo[2].get(iLoop)).booleanValue();
           dtmProgramListenerInfo.setValueAt(new Boolean(bStatus),iLoop,2);

            /* if(bStatus == true)
            {

                //jtConfiguration.
            }
            else
            {
                dtmProgramListenerInfo.setValueAt("",iLoop,2);
            }*/
        }
    }
    else
    {
        System.out.println("No Listeners Registered");
    }


    //dtmProgramListenerInfo.addRow()


  }

  public static void main(String[] args) {
     /* try {
            javax.swing.UIManager.setLookAndFeel("com.birosoft.liquid.LiquidLookAndFeel");
           
        } catch (Exception e) {
            e.printStackTrace();
        }*/
    ConfigurationServerUI configurationServerUI = new ConfigurationServerUI();
    configurationServerUI.setResizable(false);
    configurationServerUI.setBounds(100,100,520,400);
    configurationServerUI.setVisible(true);
    configurationServerUI.show();
  }

  private void jbInit() throws Exception {

      setIconImage(new ImageIcon("jlisten.jpg").getImage());

/*
      SplashScreen objScreen = new SplashScreen();
      objScreen.show();
      try
      {
         Thread.sleep(2000);
      }
      catch(Exception e)
      {

      }
      objScreen.hide();
*/

       dtmProgramListenerInfo = new DefaultTableModel() {
              // This method returns the Class object of the first
              // cell in specified column in the table model.
              // Unless this method is overridden, all values are
              // assumed to be the type Object.
              public Class getColumnClass(int columnIndex) {
                  Object o = getValueAt(0, columnIndex);
                  if (o == null) {
                      return Object.class;
                  } else {
                      return o.getClass();
                  }
              }
          };

      jtConfiguration = new JTable(dtmProgramListenerInfo);

      jtConfiguration.setEnabled(false);

      dtmProgramListenerInfo.addColumn("IP Address", new Object[]{new String()});
      dtmProgramListenerInfo.addColumn("Port No", new Object[]{new String()});
      dtmProgramListenerInfo.addColumn("Availability", new Object[]{Boolean.FALSE});



/*
          dtmProgramListenerInfo.addColumn("Icon", new Object[]{new ImageIcon("icon.gif")});
          dtmProgramListenerInfo.addColumn("Number", new Object[]{new Integer(1)});
          dtmProgramListenerInfo.addColumn("Object", new Object[]{"object"});
*/



    jlPrograms = new JList(dlmProgramsList);
    jspConfiguration = new JScrollPane(jtConfiguration);
    this.setTitle("CONFIGURATION SERVER");

    jpContents.setLayout(null);

    jspConfiguration.setBounds(new Rectangle(190, 48, 291, 209));
    jspPrograms.setBounds(new Rectangle(27, 48, 118, 209));

    loadPrograms();

    jtConfiguration = new JTable(dtmProgramListenerInfo);
    jtConfiguration.setEnabled(false);

    jpHeader.setMinimumSize(new Dimension(246, 38));
    jpLabel.setBorder(BorderFactory.createEtchedBorder());
    jpContents.setBorder(BorderFactory.createEtchedBorder());
    jlProgramsList.setHorizontalAlignment(SwingConstants.CENTER);
    jlProgramsList.setText("Programs");
    jlProgramsList.setBounds(new Rectangle(25, 7, 119, 21));
    jlblListenersList.setHorizontalAlignment(SwingConstants.CENTER);
    jlblListenersList.setText("Listeners Status");
    jlblListenersList.setBounds(new Rectangle(266, 9, 132, 20));
    jpContents.add(jlProgramsList);
    jpContents.add(jlblListenersList);
    jpContents.add(jspConfiguration);
    jpContents.add(jspPrograms);
    jspPrograms.setViewportView(jlPrograms);

    jpConfServer.setLayout(blConfigurationServer);
    jpHeader.setBorder(BorderFactory.createEtchedBorder());
    jpHeader.setPreferredSize(new Dimension(400, 40));
    jpHeader.setRequestFocusEnabled(true);
    jpHeader.setLayout(objFLHeader);
    jlblStatus.setHorizontalAlignment(SwingConstants.CENTER);
    jlblStatus.setHorizontalTextPosition(SwingConstants.TRAILING);
    jlblStatus.setText("");
    jpLabel.setPreferredSize(new Dimension(400, 50));
    jpLabel.setLayout(objFLLabel);
    jlPrograms.addListSelectionListener(this);
    jpContents.setPreferredSize(new Dimension(400, 300));
    jpContents.setLayout(null);
    jlblHeader.setFont(new java.awt.Font("SansSerif", 1, 18));
    jlblHeader.setHorizontalAlignment(SwingConstants.CENTER);
    jlblHeader.setText("CONFIGURATION SERVER");
    jspConfiguration.setBorder(BorderFactory.createEtchedBorder());
    jspPrograms.setBorder(BorderFactory.createEtchedBorder());
    jpNetworkInfo.setLayout(blNetworkInfo);
    jpNetworkInfoHeader.setBorder(BorderFactory.createEtchedBorder());
    jpNetworkInfoHeader.setMinimumSize(new Dimension(600, 40));
    jpNetworkInfoHeader.setPreferredSize(new Dimension(600, 40));
    jpNetworkInfoStatus.setPreferredSize(new Dimension(600, 30));
    jpNetworkInfoStatus.setBorder(BorderFactory.createEtchedBorder());
    jpNetworkInfoStatus.setMinimumSize(new Dimension(600, 30));
    jtpConfServer.setPreferredSize(new Dimension(805, 376));
    jpNetworkInputs.setBorder(BorderFactory.createEtchedBorder());
    jpNetworkInputs.setLayout(null);
    jpConfServerInfo.setBorder(BorderFactory.createLineBorder(Color.black));
    jpConfServerInfo.setBounds(new Rectangle(92, 43, 317, 190));
    jpConfServerInfo.setLayout(null);
    jlblConfServerIPAddress.setText("IP Address");
    jlblConfServerIPAddress.setBounds(new Rectangle(28, 39, 94, 23));
    jlblConfServerPortNo.setBounds(new Rectangle(28, 84, 94, 23));
    jlblConfServerPortNo.setText("Port Number");
    jtfIPAddress.setText("");
    jtfIPAddress.setBounds(new Rectangle(179, 39, 98, 22));
    jtfPortNo.setBounds(new Rectangle(179, 84, 98, 22));
    jtfPortNo.setText("");
    jbUpdate.setBounds(new Rectangle(105, 132, 89, 27));
    jbUpdate.setToolTipText("");
    jbUpdate.setMnemonic('U');
    jbUpdate.setText("Update");
    jlblNetworkInfo.setFont(new java.awt.Font("SansSerif", 1, 16));
    jlblNetworkInfo.setText("Network Information");
    this.getContentPane().add(jtpConfServer, BorderLayout.NORTH);
    jtpConfServer.add(jpConfServer,   "Configuration Server");

    jbRefresh.setBounds(200,0,150,30);
    jbRefresh.addActionListener(new ActionListener()
    {
        public void actionPerformed(ActionEvent ae)
        {
            try
            {
//            System.out.println("Action Performed for REFRESH");

            String sSelectedProgram = null;
            if(jlPrograms.isSelectionEmpty()==false)
                sSelectedProgram = (String)jlPrograms.getSelectedValue();


  //          System.out.println(sSelectedProgram);
  //          System.out.println("after getting program name from list");
            Vector vPrograms = ConfigurationManager.getProgramNames();
 //           System.out.println("after getting program names");
            if(vPrograms != null)
            {
 //               System.out.println("vPrograms not equal to null in ConfServerUI");
//                if(dlmProgramsList.isEmpty()!=false)
                {
                    dlmProgramsList.removeAllElements();
                }
//                else
                {
//                    System.out.println("No Programs in Programs List");
                }

                for(int iLoop=0; iLoop<vPrograms.size(); iLoop++)
                {
                    dlmProgramsList.addElement(vPrograms.get(iLoop));
                }

                if(sSelectedProgram !=null)
                {
                    jlPrograms.setSelectedValue(sSelectedProgram,true);

                    loadProgramListenerInfo(sSelectedProgram);
                }

            }
            else
            {
                System.out.println("No Programs registered so far");
            }

        }

        catch(Exception e)
        {
            System.out.println("Exception Occurred while refreshing Listener, Program details");
        }
        }
    }
    );
    jpLabel.add(jbRefresh);

    jpConfServer.add(jpHeader,  BorderLayout.NORTH);
    jpHeader.add(jlblHeader, null);
    jpConfServer.add(jpLabel, BorderLayout.SOUTH);
    jpLabel.add(jlblStatus, null);
    jpConfServer.add(jpContents,  BorderLayout.CENTER);
    jtpConfServer.add(jpNetworkInfo,   "Network Info");
    jpNetworkInfo.add(jpNetworkInfoHeader, BorderLayout.NORTH);
    jpNetworkInfoHeader.add(jlblNetworkInfo, null);
    jpNetworkInfo.add(jpNetworkInfoStatus,  BorderLayout.SOUTH);
    jpNetworkInfo.add(jpNetworkInputs, BorderLayout.CENTER);
    jpNetworkInputs.add(jpConfServerInfo, null);
    jpConfServerInfo.add(jlblConfServerIPAddress, null);
    jpConfServerInfo.add(jlblConfServerPortNo, null);
    jpConfServerInfo.add(jtfIPAddress, null);
    jpConfServerInfo.add(jtfPortNo, null);
    jpConfServerInfo.add(jbUpdate, null);

    initialiseNetworkInfo();

    jbUpdate.addActionListener(new ActionListener()
    {
        public void actionPerformed(ActionEvent ae)
        {

            if(jtfIPAddress.getText().length() <=0 || jtfPortNo.getText().length() <=0)
            {
                JOptionPane.showMessageDialog(null,"Enter IP Address, Port Number","Error",JOptionPane.ERROR_MESSAGE);
            }
            else
            {
                if(objCM.setNetworkInfo(jtfIPAddress.getText(), jtfPortNo.getText()))
                {
                    JOptionPane.showMessageDialog(null,"Network Information Updated successfully !","Update Successful",JOptionPane.INFORMATION_MESSAGE);
                }
                else
                {
                    JOptionPane.showMessageDialog(null,"Network Information Not Updated !","Error",JOptionPane.ERROR_MESSAGE);
                }
            }
        }
    }
    );


  }
    private void initialiseNetworkInfo()
    {
        String[] sNetworkInfo = objCM.getNetworkInfo();

        if(sNetworkInfo[0] != null && sNetworkInfo[1] !=null)
        {
            jtfIPAddress.setText(sNetworkInfo[0]);
            jtfPortNo.setText(sNetworkInfo[1]);
        }

    }
}