package business;

import query.Parse;
import query.Node;

import java.io.*;


public class FileManager  implements access.DatabaseConstants
{
    //private final String sMainPath="../..";
    private final String sMainPath="../../JLISTEN";
    private final String sLSLPath=sMainPath+"/lsl/";
    private final String sDecoratedPath=sMainPath+"/decorated/";

    private final String sRMIInterface="ExecPlatformInterface.class";

    //private final String sActualFilesPath="../execplatform";
    private final String sActualFilesPath="execplatform";
    //private final String sActualFilesPath="instrumentor/execplatform";
    private final String sStubPath = "execplatform/ConfigurationServer_Stub.class";
    private final String sSkelPath = "execplatform/ConfigurationServer_Skel.class";

    private final String sRMIPath =sActualFilesPath+"/"+sRMIInterface;
    private final String sEventInfoPath=sActualFilesPath+"/EventInfo.class";
    private final String sConnectionFilePath=sActualFilesPath+"/Connection.java";

    private final String sConfigurationFilePath = CONF_SERVER_INFO + "/config.txt";

    private final String sImportConnectionHeader="package ";
    private final String sRMIPackage="rmi";
    private final String sNetworkPackage="network";

    public FileManager()
    {
        File fLSLDir = new File(sLSLPath);

         if(fLSLDir.exists() == false)
               fLSLDir.mkdirs();
    }


    private void writeDecoratedCode(String sJavaFilePath , Parse objParse)
    {
        if(objParse != null)
        {
            try
            {
             System.out.println("Java File Path : "+sJavaFilePath);
            Node objRoot=objParse.getRoot();
            File fDecoratedFile=new File(sJavaFilePath);

            FileWriter fwDecoratedFile = new FileWriter(fDecoratedFile);
            objRoot.print(objParse.getCommentList(), fwDecoratedFile);
            fwDecoratedFile.close();

            }
            catch (IOException e)
            {
                System.out.println("DECORATED FILE EXCEPTION");
            }
        }
     }

    public boolean storeLSLFile(String[] sLSL, String sJavaFileName)
    {
        FileWriter fwLSL = null;

        try
        {
            fwLSL = new FileWriter(sLSLPath+sJavaFileName);

            for(int iLoop=0 ;iLoop < sLSL.length; iLoop++)
            {
                fwLSL.write(sLSL[iLoop]);
                fwLSL.write('\n');
            }

            fwLSL.close();
        }

        catch(Exception e)
        {
            System.out.println("Exception Occurred while storing LSL");
            return false;
        }
        return true;
    }


    public  boolean createInstrumentedPackage(String sJavaFileName , Parse objParse)
    {

       //String sImportConnection=sImportConnectionHeader+sJavaFileName+";\n";
        String sImportConnection="";
       String sDecorated = sDecoratedPath+sJavaFileName+"/";
       String sRMIinDecorated=sDecorated+sRMIPackage+"/" ;
       String sNetworkinDecorated = sDecorated + sNetworkPackage +"/";

        //System.out.println("DECORATED PATH="+sDecorated);
        //System.out.println("RMI PATH="+sRMIinDecorated);
        int iChar=-1;
        File fRMIPackage= new File(sRMIinDecorated);
        File fDecoratedPackage= new File(sDecorated);
        File fNetworkPackage= new File(sNetworkinDecorated);

        System.out.println("Decorated Package made status : " + fDecoratedPackage.mkdirs());
        System.out.println("RMI Package made status : " +fRMIPackage.mkdirs());
        System.out.println("Network Package made status : " +fNetworkPackage.mkdirs());

        try
        {

            //System.out.println("Event Info Path" + sEventInfoPath);


            fileCopy(sEventInfoPath,sRMIinDecorated+"EventInfo.class");
            fileCopy(sStubPath,sNetworkinDecorated+"ConfigurationServer_Stub.class");

            fileCopy(sSkelPath,sNetworkinDecorated+"ConfigurationServer_Skel.class");

            fileCopy(sConfigurationFilePath,sRMIinDecorated+"config.txt");

            fileCopy(sActualFilesPath+"/ExecPlatformInterface.class",sRMIinDecorated+"ExecPlatformInterface.class");

            fileCopy(sActualFilesPath+"/ListenerInterface.class",sRMIinDecorated+"ListenerInterface.class");
            fileCopy(sActualFilesPath+"/AuralizerInterface.class",sRMIinDecorated+"AuralizerInterface.class");

            fileCopy(sActualFilesPath+"/ConfServerInterface.class",sRMIinDecorated+"ConfServerInterface.class");

            fileCopy(sConnectionFilePath,sRMIinDecorated+"Connection.java");


            writeDecoratedCode(sDecorated+"/"+sJavaFileName+".java" , objParse);

        }
        catch(Exception e)
        {
            e.printStackTrace();
            System.out.println("Exception Occurred in File Manager");
        }

        return true;
    }


    public boolean fileCopy(String sSource, String sDestination)
    {
        try
        {
        FileInputStream fis = new FileInputStream(sSource);
        FileOutputStream fos = new FileOutputStream(sDestination);

        //System.out.println("\n\nInput File Path : " + new File(sSource).getAbsolutePath());
        //System.out.println("\n\nOutput File Path : " + new File(sDestination).getAbsolutePath());

        int iSize = fis.available();
        byte bArray[]=null;

        if(iSize != 0)
        {
            bArray = new byte[iSize];

            int iBytesRead= fis.read(bArray);
            //System.out.println("Bytes Read : " + iBytesRead);
            fos.write(bArray);

            fis.close();
            fos.close();

            return true;
        }
        else
        {
            return false;
        }
        }
        catch(IOException ioe)
        {
            System.out.println("Exceptoin Occurred while copying File : Source - " + sSource + " Destination - " + sDestination);
            //ioe.printStackTrace();
            return false;
        }
    }

}




