package business;

import java.util.Vector;

public class LSLCreator implements LSLSpecifiers
{
   private InstrumentLoader objInstrumentLoader = null;

   public LSLCreator()
   {
        objInstrumentLoader =  new InstrumentLoader();
   }

   public Vector getInstrumentNames()
   {
       return objInstrumentLoader.loadInstrumentNames();
   }

   public String[] getEvents()
   {
        return sEvents;
   }

   public String[] getScopes()
   {
       return sScopes;
   }

    public String[] getLSLBodyTemplate(String sJavaFileName)
    {
       String[] sLSL= {"begin auralspec","specmodule "+sJavaFileName,"begin "+sJavaFileName,"end "+sJavaFileName,"end auralspec"};

        return sLSL;
    }


   public String createLSLStatement(LSLTokens objTokens)
   {
       StringBuffer sbLSL = new StringBuffer();
       String sKeyword=objTokens.getKeyword();
       String sIdentifier=objTokens.getIdentifier();
       String sMethod=objTokens.getMethodName();
       String sClass=objTokens.getClassName();
       String sPackage=objTokens.getPackageName();

       sbLSL.append("notify");

       if((sPackage == null) && (sMethod==null) && (sClass==null))
       {
         sbLSL.append(" all");
       }

       if(sKeyword != null)
       {

          if(sKeyword.equalsIgnoreCase("switch_case_begin") == true)
          {
              System.out.println("SWITCH PLEASE----------"+objTokens.getParameters().get(0).toString());
              if((objTokens.getParameters()!=null)&& objTokens.getParameters().size()==1)
                sbLSL.append(" switch_case_begin in case="+objTokens.getParameters().get(0));
              else
                sbLSL.append(" switch_case_begin");
          }
          else if(sKeyword.equalsIgnoreCase("dtrack") == true)
          {
             sbLSL.append(" dtrack "+sIdentifier);
          }
          else if(sKeyword.equalsIgnoreCase("method_call_begin") == true)
          {
             sbLSL.append(" method=method_call_entry: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
          }
          else if(sKeyword.equalsIgnoreCase("method_call_end") == true)
          {
             sbLSL.append(" method=method_call_exit: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
          else if(sKeyword.equalsIgnoreCase("method_body_end") == true)
          {
             sbLSL.append(" method=method_body_end: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
          else if(sKeyword.equalsIgnoreCase("method_body_begin") == true)
          {
             sbLSL.append(" method=method_body_begin: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
           else if(sKeyword.equalsIgnoreCase("recursion_method_body_end") == true)
          {
             sbLSL.append(" method=recursion_method_body_end: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
          else if(sKeyword.equalsIgnoreCase("recursion_method_body_begin") == true)
          {
             sbLSL.append(" method=recursion_method_body_begin: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
          else if(sKeyword.equalsIgnoreCase("finalize") == true)
          {
             sbLSL.append(" finalize=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("finally") == true)
          {
             sbLSL.append(" finally=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("constructor") == true)
          {
             sbLSL.append(" classinstantiation=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("super") == true)
          {
             sbLSL.append(" super=\""+sIdentifier+"\"");
          }
          else if((sKeyword.equalsIgnoreCase("atrack_method") == true) || (sKeyword.equalsIgnoreCase("atrack_class") == true)|| (sKeyword.equalsIgnoreCase("atrack_recursion_method") == true))
          {
             sbLSL.append(" atrack when "+sIdentifier+"_begin until "+sIdentifier+"_end");
          }
         else
          {
            sbLSL.append(" rule="+sKeyword);
          }
        }

        if(sMethod != null)
        {
            sbLSL.append(" in method="+sMethod);
        }
        if(sClass != null)
        {
            sbLSL.append(" in class="+sClass);
        }
        if(sPackage != null)
        {
            sbLSL.append(" in package="+sPackage);
        }

       sbLSL.append(" using "+objTokens.getInstrument()+" with note=\""+getNoteName(objTokens.getNote())+"\" ;");


       return sbLSL.toString();
   }
    public  String getNoteName(int scrollValue)
    {
        int octaveNum=0, noteNum=0;
          String midiValueString=null;

        octaveNum=0;
        noteNum=0;
        midiValueString=null;

          octaveNum = (int) scrollValue/12;
          noteNum = (int) scrollValue%12;

          switch(noteNum) {
            case 0:
              midiValueString = new String("C");
              break;
            case 1:
              midiValueString = new String("Db");
              break;
            case 2:
              midiValueString = new String("D");
              break;
            case 3:
              midiValueString = new String("Eb");
              break;
            case 4:
              midiValueString = new String("E");
              break;
            case 5:
              midiValueString = new String("F");
              break;
            case 6:
              midiValueString = new String("Gb");
              break;
            case 7:
              midiValueString = new String("G");
              break;
            case 8:
              midiValueString = new String("Ab");
              break;
            case 9:
              midiValueString = new String("A");
              break;
            case 10:
              midiValueString = new String("Bb");
              break;
            case 11:
              midiValueString = new String("B");
              break;
            default:
              midiValueString = new String();
          }

          midiValueString = midiValueString + octaveNum;
        return midiValueString;
    }

}

