package business;

import java.io.Serializable;
import java.util.Vector;

public class LSLTokens implements Serializable
{
    private String sClassName = null;
    private String sMethodName = null;
    private String sPackageName = null;
    private Vector vMethodScopeParameters;
    private String sKeyword = null;
    private String sIdentifier = null;
    private boolean bActivity = false;
    private String sInstrument =null;
    private Vector vInstrumentList =null;
    private Vector vParameters= null;
    private Vector vMethodReturnValues=null;
    private int iDataType=-1;
    private String sPatchMethodName=null;
    private int iNote=0;
    private Vector vNoteList=null;

    public LSLTokens(String sPackage, String sClass, String sMethod, Vector vMethodParameters,String sKeyword,
                     String sIdentifier, boolean bActivity, String sInstrument, Vector vParameters, int iNote)
    {
        this.sClassName=sClass;
        this.sPackageName=sPackage;
        this.sMethodName=sMethod;
        this.vMethodScopeParameters=vMethodParameters;
        this.sKeyword=sKeyword;
        this.sIdentifier=sIdentifier;
        this.sInstrument=sInstrument;
        this.bActivity=bActivity;
        this.vParameters=vParameters;
        this.iNote=iNote;
    }

    public LSLTokens(String sPackage, String sClass, String sMethod, Vector vMethodParameters,
                     String sKeyword, Vector vValues, boolean bActivity, Vector vInstrument, Vector vParameters,
                     Vector vNote, int iDataType, String sPatchMethodName,String sIdentifier)
        {
            this.sClassName=sClass;
            this.sPackageName=sPackage;
            this.sMethodName=sMethod;
            this.vMethodScopeParameters=vMethodParameters;
            this.sKeyword=sKeyword;
            this.vMethodReturnValues=vValues;
            this.vInstrumentList=vInstrument;
            this.bActivity=bActivity;
            this.vParameters=vParameters;
            this.vNoteList=vNote;
            this.iDataType=iDataType;
            this.sPatchMethodName=sPatchMethodName;
            this.sIdentifier=sIdentifier;
        }

    public LSLTokens()
    {

    }

    public int getNote()
    {
        return iNote;
    }

    public void setNote(int iNote)
    {
        this.iNote=iNote;
    }
    public String getClassName() {
        return sClassName;
    }

    public void setClassName(String sClassName) {
        this.sClassName = sClassName;
    }

    public String getMethodName() {
        return sMethodName;
    }

    public void setMethodName(String sMethodName) {
        this.sMethodName = sMethodName;
    }

    public String getPackageName() {
        return sPackageName;
    }

    public void setPackageName(String sPackageName) {
        this.sPackageName = sPackageName;
    }

    public String getKeyword() {
        return sKeyword;
    }

    public void setKeyword(String sKeyword) {
        this.sKeyword = sKeyword;
    }

    public String getIdentifier() {
        return sIdentifier;
    }

    public void setIdentifier(String sIdentifier) {
        this.sIdentifier = sIdentifier;
    }


    public String getInstrument() {
        return sInstrument;
    }

    public void setInstrument(String sInstrument) {
        this.sInstrument = sInstrument;
    }

    public Vector getParameters() {
        return vParameters;
    }

    public void setParameters(Vector vParameters) {
        this.vParameters = vParameters;
    }

    public int getNoofParameters()
    {
        if(vParameters == null)
        {
            return -1;
        }
        else
        {
            return vParameters.size();
        }
    }

    public int getNoofMethodScopeParameters()
    {
        if(vMethodScopeParameters == null)
        {
            return -1;
        }
        else
        {
            return vMethodScopeParameters.size();
        }
    }

    public boolean isActivity() {
        return bActivity;
    }

    public void setActivity(boolean bActivity) {
        this.bActivity = bActivity;
    }

    public Vector getMethodScopeParameters() {
        return vMethodScopeParameters;
    }

    public void setMethodScopeParameters(Vector vMethodScopeParameters) {
        this.vMethodScopeParameters = vMethodScopeParameters;
    }

    public int getDataType()
    {
        return iDataType;
    }

    public void setDataType(int iDataType)
    {
        this.iDataType = iDataType;
    }

   
    public String getPatchMethodName() {
        return sPatchMethodName;
    }

    public void setPatchMethodName(String sPatchMethodName) {
        this.sPatchMethodName = sPatchMethodName;
    }

    public Vector getMethodReturnValues() {
        return vMethodReturnValues;
    }

    public void setMethodReturnValues(Vector vMethodReturnValues) {
        this.vMethodReturnValues = vMethodReturnValues;
    }

    public Vector getInstrumentList() {
        return vInstrumentList;
    }

    public void setInstrumentList(Vector vInstrumentList) {
        this.vInstrumentList = vInstrumentList;
    }

    public Vector getNoteList() {
        return vNoteList;
    }

    public void setNoteList(Vector vNoteList) {
        this.vNoteList = vNoteList;
    }

}