  package business;
import query.Parse;
import query.Node;
import query.Constants;

import java.io.*;

public class TestFor implements Constants
{
    public static void annotate(Parse p)
    {
        Node n = p.getRoot();
        Node for_node;
        for_node = n.find(Constants.FORSTATEMENT,true);
        int nc =for_node.getNumChildren();
        //for(int index = 0;index < nc;index ++)
        //if(for_node.getChild(index).isTerm())
        //System.out.println(for_node.getChild(index).getType());

        switch(for_node.getChild(nc-1).getChild(0).getType() )
        {
            case Constants.EMPTYSTATEMENT : System.out.println("Blank Statement");
                for_node.getLast().setAnnotation("for_inst()",null);
                break;
            case Constants.STATEMENTEXPRESSION : System.out.println("Single Statement");
                for_node.getChild(nc-1).getFirst().setAnnotation("{for_inst();",null);
                for_node.getLast().setAnnotation("}",null);
                break;
            case Constants.BLOCK : System.out.println("Brace");
                for_node.getChild(nc-1).getFirst().setAnnotation(null,"for_inst();\n");
                break;
            case Constants.FORSTATEMENT:
                case Constants.IFSTATEMENT :
                case Constants.DOSTATEMENT :
                case Constants.WHILESTATEMENT :
                System.out.println("For|IF|DO_WHILE|WHILE");
                for_node.getChild(nc-1).getFirst().setAnnotation("{instrfor();",null);
                for_node.getChild(nc-1).getLast().setAnnotation(null,"}");
                break;
          }
    }

    public static void main(String[] args)
    {
        Parse p = new Parse(args[0]);
        if(p.getError() != null)
            System.err.println("Error in Parsing");

        // Parse p = new Parse(args[0]);

        else {
            Node root = p.getRoot();
            annotate(p);
            try {
                FileDescriptor o = FileDescriptor.out;
                Writer w = new FileWriter(o);
                w = new BufferedWriter(w);
                root.print(p.getCommentList(), w);
                w.close();
            }
            catch (IOException e) {
                System.err.println(e);
            }
        }
    }

}
