package rmi;

import java.rmi.Naming;
import java.io.File;
import java.io.FileReader;
import java.util.StringTokenizer;

public class Connection 
{
    private static ExecPlatformInterface objEPI = null;
    private static String sIPAddress = null;
    private static String sPort= null;
    private static final String sConfigurationPath="rmi/config.txt";
    private static File fConfig = null;

    public Connection()
    {

    }

    public static boolean connectConfServer()
    {

        try
        {
            fConfig = new File(sConfigurationPath);
            //System.out.println("File Path : " + fConfig.getAbsolutePath());
            if(fConfig.exists() == false)
            {
                System.out.println("File not found : " + fConfig.getAbsolutePath());
            }
            else
            {
                char cBuffer[] = new char[20];
                FileReader frConfig = new FileReader(fConfig);
                if(frConfig.read(cBuffer) == -1)
                {
                    System.out.println("Failed to load Network Information");
                }
                String sBuffer=new String(cBuffer);
                StringTokenizer stToken = new StringTokenizer(sBuffer,":");
                sIPAddress=stToken.nextToken();
                sPort=stToken.nextToken();

                System.out.println(" IPAddress : "+sIPAddress+"- Port No : "+sPort);
            }
        }
        catch(Exception e)
        {
            System.out.println("Configuration Server Info Exception");
        }

        try
        {
            objEPI = (ExecPlatformInterface)javax.rmi.PortableRemoteObject.narrow(Naming.lookup("rmi://"+ sIPAddress + ":" + sPort + "/EXECPLATFORM_SERVER"),ExecPlatformInterface.class);
            if(objEPI !=null)
            {
                System.out.println("Execution Platform Connected");
            }
            else
            {
                System.out.println("Excecution Platform Not Connected");
            }
            return true;
        }
        catch(Exception e)
        {
            e.printStackTrace();
            System.out.println("Exception at Listener Interface Communicator");
            return false;
        }
    }

    public static ExecPlatformInterface getConnectionReference()
    {
        return objEPI;
    }
}