package network;


import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.util.StringTokenizer;

public class ConfigurationServerInfo implements access.DatabaseConstants
{
   private String sIPAddress;
   private String sPort;
   private final String sConfigurationPath=CONF_SERVER_INFO + "/" + "config.txt";
   private File fConfig = null;

    public ConfigurationServerInfo()
    {
        try
        {
             fConfig = new File(sConfigurationPath);
             //System.out.println("Configuration Path in ConfigurationServerInfo" + fConfig.getAbsolutePath());
             if(fConfig.exists() == false)
             {
                fConfig.createNewFile();
             }
             else
             {
               //  System.out.println("Else part of ConfServer Info CONSTRUCTOR");
                char cBuffer[] = new char[20];
                FileReader frConfig = new FileReader(fConfig);
                if(frConfig.read(cBuffer) == -1)
                {
                    System.out.println("Instrumentor failed loading Network Info");
                }
                 String sBuffer=new String(cBuffer);
                 StringTokenizer stToken = new StringTokenizer(sBuffer,":");
                 sIPAddress=stToken.nextToken();
                 sPort=stToken.nextToken();

             }
        }
        catch(Exception e)
        {

            System.out.println("Configuration Info Exception");
        }
    }

    public String getIPAddress() {
        return sIPAddress;
    }

    public void setIPAddress(String sIPAddress) {
        this.sIPAddress = sIPAddress;
    }

    public String getPort() {
        return sPort;
    }

    public void setPort(String sPort) {
        this.sPort = sPort;
    }

    public void setNetworkInfo(String sIPAddress, String sPort)
    {
        this.sIPAddress=sIPAddress;
        this.sPort=sPort;

        FileWriter fwConfig = null;

        try
        {
            System.out.println("Configuraiton Path : " + sConfigurationPath);
            fwConfig = new FileWriter(sConfigurationPath);
            fwConfig.write(this.sIPAddress);
            fwConfig.write(":");
            fwConfig.write(this.sPort);
            fwConfig.write(":");
            fwConfig.close();
        }
        catch(Exception e)
        {
            System.out.println("Exception Occurred while setting Network Information ");
        }
    }

    public String[] getNetworkInfo()
    {
        String sInfo[]= new String[2];

        sInfo[0]=sIPAddress;
        sInfo[1]=sPort;

        return sInfo;
    }

}