package business;

import javax.sound.midi.*;
import java.util.Vector;
import java.util.Hashtable;

public class ActivityPlayer extends Thread {


    private Synthesizer objSynth = null;
    private MidiChannel[] objChannels = null;

    private Hashtable htInstruments = null;
    private Instrument objInstruments[] = null;
    private final int CHANNEL_NUMBER = 0;
    private final int CHANNEL_NUMBER_ACTIVITY = 1;
//    private final int DEFAULT_NOTE = 90;
    private final int DEFAULT_NOTE_ACTIVITY = 100;
    private final int VELOCITY=1000;

    private boolean bExitFlag=false;
    private boolean bSuspend=false;

    private Vector vSoundProperties=null;

    public ActivityPlayer()
    {

        htInstruments = new Hashtable();
        try
        {
                objSynth = MidiSystem.getSynthesizer();
                objSynth.open();
        }
        catch (MidiUnavailableException mue)
        {
          System.out.println("MIDI EXCEPTION ");

        }

        objInstruments = objSynth.getAvailableInstruments();
        objChannels = objSynth.getChannels();
        mapInstrumentNames();
    }

    public void playActivitiesSound(Vector vSoundProperties)
    {
          this.vSoundProperties=vSoundProperties;
          this.start();
    }

    public  Vector getInstrumentNames()
    {
       Vector vInstrument = new Vector();

       for(int iLoop=0; iLoop < objInstruments.length; iLoop++)
       {
            vInstrument.add(objInstruments[iLoop].getName().trim());
       }

        return vInstrument;
    }

    private void mapInstrumentNames()
    {

       for(int iLoop=0; iLoop < objInstruments.length; iLoop++)
       {
            htInstruments.put(objInstruments[iLoop].getName().trim(),new Integer(iLoop));
            //System.out.println("MAP------INSTR-"+htInstruments.get(objInstruments[iLoop].getName())+"--VAL---"+htInstruments.get(objInstruments[iLoop].getName()));
       }

    }

    public void run()
    {
        String sSoundVariable = (String)vSoundProperties.get(0);
        int iNote = ((Integer)vSoundProperties.get(1)).intValue();
        String sTime = (String)vSoundProperties.get(2);
        boolean bStatus = ((Boolean)(vSoundProperties.get(3))).booleanValue();

        //this.iNote = iNote;
        int iInstrument=0;
        try{
             iInstrument= ((Integer)htInstruments.get(sSoundVariable)).intValue();
        }
        catch(Exception e)
        {
           System.out.println("INSTRUMENT NOT FOUND");
        }

        if(bStatus)
        {
             objSynth.loadInstrument(objInstruments[iInstrument]);
             objChannels[CHANNEL_NUMBER_ACTIVITY].programChange(iInstrument);

           while(!bExitFlag){
               if(bSuspend)
               {
                  objChannels[CHANNEL_NUMBER_ACTIVITY].allNotesOff();
               }
               else
               {
                    objChannels[CHANNEL_NUMBER_ACTIVITY].noteOn(DEFAULT_NOTE_ACTIVITY, VELOCITY); //change constants

                    try{
                        Thread.sleep(500);
                    }
                    catch(Exception e)
                    {
                        System.out.println("EXCEPTION SOUND");
                    }

               }
           }
                bExitFlag=false;
        }
        else
        {
            objChannels[CHANNEL_NUMBER_ACTIVITY].noteOff(DEFAULT_NOTE_ACTIVITY);
        }
    }


    public void suspendThread()
    {
         bSuspend=true;
    }

    public void resumeThread(){
        bSuspend=false;
    }
    public void stopActivitiesSound()
    {
        bExitFlag=true;
        objChannels[CHANNEL_NUMBER_ACTIVITY].allNotesOff();
    }

    public void mute(boolean bStatus)
    {
        objChannels[CHANNEL_NUMBER].setMute(bStatus);
    }
}