package business;

import javax.sound.midi.*;
import javax.sound.sampled.AudioSystem;
import java.util.Vector;
import java.util.Hashtable;
import java.io.File;
import java.io.FileInputStream;
import java.io.BufferedInputStream;


public class SoundSynthesizer implements MIDIConstants
{
    private Synthesizer objSynth = null;
    private ChannelData objChannels[] = null;
    private ChannelData cc=null;
/*
private final int PROGRAM = 192;
private final int NOTEON = 144;
private final int NOTEOFF = 128;
private final int SOUND_DELAY=500;
private final int MIDI_INSTRUMENTS_LENGTH=128;
*/


    private Hashtable htInstruments = null;
    private Instrument objInstruments[] = null;

    private final int CHANNEL_NUMBER = 0;


    public SoundSynthesizer()
    {
        htInstruments = new Hashtable();
        /*try
        {
        objSynth = MidiSystem.getSynthesizer();
        objSynth.open();

        objActivitySyntheshizer = MidiSystem.getSynthesizer();
        objActivitySyntheshizer.open();
        }
        catch (MidiUnavailableException mue)
        {
        System.out.println("MIDI EXCEPTION ");

        }

        objInstruments = objSynth.getAvailableInstruments();
        objChannels = objSynth.getChannels();
        objActivityChannels = objActivitySyntheshizer.getChannels();*/
        open();
        mapInstrumentNames();
        cc.channel.controlChange(REVERB, cc.reverb);
        cc.channel.setChannelPressure(cc.pressure);
        cc.channel.setPitchBend(cc.bend);
        //cc.channel.controlChange(SUSTAIN, cc.sustain ? 127 : 0);
    }

    /**
     * Stores MidiChannel information.
     */

    class ChannelData {

        MidiChannel channel;
        boolean solo, mono, mute, sustain;
        int velocity, pressure, bend, reverb;
        // int row, col;
        int num;

        public ChannelData(MidiChannel channel, int num) {
            this.channel = channel;
            this.num = num;
            sustain=true;
            velocity = pressure = reverb = 64;
            bend = 8192;
        }
    } // End class ChannelData


    public void open() {
        try {
            if (objSynth == null) {
                if ((objSynth = MidiSystem.getSynthesizer()) == null) {
                    System.out.println("getSynthesizer() failed!");
                    return;
                }
            }
            objSynth.open();

        } catch (Exception ex) {

            ex.printStackTrace(); return; }

        //System.out.println("SYHTN====="+objSynth);
        Soundbank sb = objSynth.getDefaultSoundbank();
        //System.out.println("BANK===="+sb);
        if (sb != null) {
            //System.out.println("BANK===="+sb);
            objInstruments = objSynth.getDefaultSoundbank().getInstruments();
            //objSynth.loadInstrument(objInstruments[0]);
        }
        MidiChannel midiChannels[] = objSynth.getChannels();
        objChannels = new SoundSynthesizer.ChannelData[midiChannels.length];
        for (int i = 0; i < objChannels.length; i++) {
            objChannels[i] = new SoundSynthesizer.ChannelData(midiChannels[i], i);
        }
        cc = objChannels[CHANNEL_NUMBER];
    }

    public void playNote(Vector vSoundProperties, Integer objData)
    {
        String sSoundVariable = (String)vSoundProperties.get(0);
        int iNote = ((Integer)vSoundProperties.get(1)).intValue();
        String sTime = (String)vSoundProperties.get(2);
        boolean bStatus = ((Boolean)(vSoundProperties.get(3))).booleanValue();

        //int iData=NOTE_ON;
        int iData = iNote;

        if(objData != null)
        {
            iData=((Integer)objData).intValue();
           if(iData < iNote)
            iData+=iNote;
           while(iData >= MAX_NOTES)
           {
               iData = (iData % MAX_NOTES) + iNote;
           }



            /*if(iData >= MAX_NOTES)
            {
                iData = iData%MAX_NOTES;
                if(iData < MAX_NOTES)
                    iData=iNote;

                if(iData == 0)
                {
                    iData = iNote;
                }
            }*/
/*

            iData =
            //iData=((iData%MAX_NOTES == 0)&& ())?NOTE_ON :iData;
*/
        }

        int iInstrument=0;
        try{
            iInstrument= ((Integer)htInstruments.get(sSoundVariable)).intValue();
        }catch(Exception e)
        {
            System.out.println("INSTRUMENT NOT FOUND");
        }


        if(bStatus)
        {
            objSynth.loadInstrument(objInstruments[iInstrument]);
            cc.channel.programChange(iInstrument);
            //objChannels[CHANNEL_NUMBER].programChange(iInstrument);
            cc.channel.noteOn(iData, cc.velocity);
            try
            {
                Thread.sleep(SOUND_DELAY);
            }catch(Exception e)
            {
            }
            cc.channel.noteOff(iData, cc.velocity);

        }


    }


    public  Vector getInstrumentNames()
    {
        Vector vInstrument = new Vector();

        for(int iLoop=0; iLoop < MIDI_INSTRUMENTS_LENGTH; iLoop++)
        {
            vInstrument.add(objInstruments[iLoop].getName().trim());
        }

        return vInstrument;
    }

    private void mapInstrumentNames()
    {

        //System.out.println("INST   "+objInstruments);
        //objInstruments.length
        for(int iLoop=0; iLoop < MIDI_INSTRUMENTS_LENGTH; iLoop++)
        {
            // System.out.println("INST   "+objInstruments[iLoop].getName().trim());
            htInstruments.put(objInstruments[iLoop].getName().trim(),new Integer(iLoop));
            //System.out.println("MAP------INSTR-"+htInstruments.get(objInstruments[iLoop].getName())+"--VAL---"+htInstruments.get(objInstruments[iLoop].getName()));

        }

    }



}